#pragma once


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <string>
#include <vector>
#include <iostream>
#include <fstream>
#include <string.h>
#include <stack>
#include <ctype.h>
#include "Parts.h"
#include <map>

#include "Transform.h"
#include "TranslateTransform.h"
#include "RotateTransform.h"
#include "DrawnObject.h"
#include "DrawnObjectBySTL.h"
#include "RangedDouble.h"
#include "GLBody.h"

#define MAX_COMMAND_LENGTH  80



/**
* ݒt@CǂݍŁCp[c̃c[𐶐NX
*
*
*/
class Parser{

	private:
typedef enum SEQUENCE_MODE{
	SEQUENCE_MODE_NONE,
	SEQUENCE_MODE_ASSEM,
	SEQUENCE_MODE_PARTS,
	SEQUENCE_MODE_CHILD,
	SEQUENCE_MODE_DRAWN_STL,
	SEQUENCE_MODE_DATAPORT,
	SEQUENCE_MODE_SWITCH
};

typedef enum COMMAND_MODE{
	BEGIN_PARTS,
	END_PARTS,
	BEGIN_ASSEM,
	END_ASSEM,
	COLOR,
	BEGIN_CHILD,
	END_CHILD,	
	BEGIN_DRAWN_STL,
	END_DRAWN_STL,
	TRANS,
	PATH,
	NEXT,
	BEGIN_DATAPORT,
	END_DATAPORT,
	COMMENT,
	BEGIN_SWITCH,
	END_SWITCH
};


	//\bh
public:
	Parser(void);
	~Parser(void);

	Parts* Execute(const char *path);	//!< ݒt@Cǂݍ݁Cp[c̃c[𐶐



	
	typedef std::map<std::string, Parts*>::iterator partsMapIterator;


	std::vector<RangedDouble*> accessedElements;
	std::vector<Parts::OutputPath*> switchedPath;
	Parts *switchTarget;

	bool DumpParts(void);

private:
	int lineCounter;
	std::ofstream paserLog;
	std::ofstream linkerLog;
	bool LinkParts(void);
	bool LinkDataPort(void);
	bool LinkSwitch(void);
	bool SerchDataPortLinedArgumentBy2(void);
	bool GetArgument(char *source,char *dest);
	bool OnBEGIN_PARTS(char *source);
	bool OnEND_PARTS(char *source);
	bool OnBEGIN_ASSEM(char *source);
	bool OnEND_ASSEM(char *source);
	bool OnCOLOR(char *source);
	bool OnBEGIN_CHILD(char *source);
	bool OnEND_CHILD(char *source);
	bool OnBEGIN_DRAWN_STL(char *source);
	bool OnEND_DRAWN_STL(char *source);
	bool OnTRANS(char *source);
	bool OnPATH(char *source);
	bool OnNEXT(char *source);
	bool OnCOMMENT(char *source);
	bool OnBEGIN_DATAPORT(char *source);
	bool OnEND_DATAPORT(char *source);
	bool OnBEGIN_SWITCH(char *source);
	bool OnEND_SWITCH(char *source);


	bool AddRotateTransform(Transform::TransformList::iterator ttit);
	bool AddTranslateTransform(Transform::TransformList::iterator ttit,char axisIndex[]);



	Parts *parts;

	//o
	std::map<std::string, Parts*> partsMap;	//ǂݍ񂾃p[cf[^͂ɓZ߂
	std::stack<SEQUENCE_MODE> sequenceMode;
	Parts::OutputPath *outputPath;
	Parts *root;		//ǂݍ񂾌ʓOtrootm[hw
	std::vector<std::string> dataPortKey;	//!< ݒt@CBEGIN DATAPORTEND DATAPORT̊Ԃɂ镶ێ
	std::vector<std::string> switchKey;

};
