#include "Parts.h"

//NX̎
Parts::OutputPath::OutputPath(std::string name){
	this->pathName = name;
	this->next = NULL;
	this->outputTrans = new Transform("Output trans");
}

Parts::OutputPath::~OutputPath(void){
}

Parts::OutputPath* Parts::CreateOutputPath(std::string name){
	Parts::OutputPath *newPath = new Parts::OutputPath(name);
	this->outputs.insert(std::pair<std::string,Parts::OutputPath*>(name,newPath));
	return newPath;
}

void Parts::OutputPath::Dump(int depth ,std::stringstream &ret){
	std::string padding = MyUtility::PaddingChar(depth,' ');
	ret << padding << "Path name = " << this->pathName << std::endl;
	
	ret << padding << "Child Parts object = ";

	if(this->childName.size()){
		ret << this->childName << std::endl;
	}else{
		ret << "NONE" << std::endl;
	}

	ret << padding << "Dump output transform" << std::endl;

	this->outputTrans->Dump(depth+2,ret);
}

void Parts::OutputPath::RegisterChild(Parts *child){
	this->next = child;
}

void Parts::OutputPath::UnregisterChild(void){
	this->next = NULL;
}

std::string Parts::OutputPath::GetPathName(void){
	return this->pathName;
}

void Parts::OutputPath::SetPathName(std::string newName){
	this->pathName = newName;
}





//ONX̎
Parts::Parts(void){
	std::cout << "Ă񂶂Ⴞ" << std::endl;
}
Parts::Parts(std::string partsName){
	this->partsName = partsName;

	this->inputTrans = new Transform("input trans");
	this->drawnObject = NULL;
}

Parts::~Parts(void){
}


bool Parts::OutputPath::IsRegisterdChild(void){
	if(this->next != NULL){
		return true;
	}else{
		return false;
	}
}

void Parts::OutputPath::ExecuteNext(void){
	this->next->ExecuteDrawing();
}


//OpenGLւ̕`
void Parts::ExecuteDrawing(void){
	//͕Wϊ
	this->inputTrans->Execute();

	//`
	if(this->drawnObject){
		this->drawnObject->Draw();
	}else{
		//std::cout << "NULLPO\n";
	}

	//qH
	OutputPathIterator opit = this->outputs.begin();
	while(opit != this->outputs.end()){
		if(opit->second->IsRegisterdChild()){
			glPushMatrix();
			opit->second->outputTrans->Execute();
			opit->second->ExecuteNext();
			glPopMatrix();
		}
		opit++;
	}

/*
	OutputPathIterator opit = this->outputs.begin();
	while(opit != this->outputs.end()){
		opit->second->outputTrans->Execute();

		opit++;
	}
*/
}



void Parts::Dump(int depth,std::stringstream &ret){
	std::string padding = MyUtility::PaddingChar(depth,' ');
	int i = 1;

	ret << padding << "Dump Parts" << std::endl;

	padding = MyUtility::PaddingChar(depth+2,' ');

	ret << padding << "Name = " << this->partsName  << std::endl;
	
	ret << padding << "Dump Input transform" << std::endl;
	this->inputTrans->Dump(depth+2,ret);
	
	ret << padding << "Dump Output path" << std::endl;

	padding = MyUtility::PaddingChar(depth+4,' ');


	ret << padding << "Number of Output path = " << this->outputs.size() << std::endl;

	if(this->outputs.size() != 0){
		Parts::OutputPathIterator it;
		it = this->outputs.begin();
		while(this->outputs.end() != it){
			ret << padding << "N.o." << i << std::endl;
			ret << padding << "Map Key = " << it->first << std::endl;
			it->second->Dump(depth+6,ret);
			it++;
			i++;
		}
	}else{
		ret << padding  << "q͓o^Ă܂" << std::endl;
	}


	padding = MyUtility::PaddingChar(depth+2,' ');
	ret << padding << "Dump DrawnObject" << std::endl;
	padding = MyUtility::PaddingChar(depth+4,' ');
	if(this->drawnObject == NULL){
		ret << padding << "`IuWFNg͓o^Ă܂" << std::endl;	
	}else{	
		this->drawnObject->Dump(depth+4,ret);
	}
	ret << "Dump complate\n";

}

void Parts::Dump(void){
	std::stringstream output;
	this->Dump(0,output);
	std::cout << output.str();
}


std::string Parts::GetName(void){
	return this->partsName;
}
void Parts::SetName(std::string newName){
	this->partsName = newName;
}


std::string Parts::GetFilePath(void){
	return this->filePath;
}

void Parts::SetFilePath(std::string path){
	this->filePath = path;
}
